<?php
error_reporting(E_ERROR & ~E_NOTICE);
$url = $argv[2];
/* for example,
 http://hr5:90/wpp/exams/a0007/token.php
*/

$timeout = 30; // seconds
$reqcnt = 0;
$sendfp = fopen('sendlog/' . $argv[1], 'a');
$recvfp = fopen('recvlog/' . $argv[1], 'a');
while($reqcnt < 100) {
    fwrite($sendfp, sprintf("%s\n", 'send'));
    $t1 = microtime(true);
    $r = usecurl(['msg'=>'dummy'], $url);
    $t2 = microtime(true);
    if (($t2-$t1) > $timeout ) 
        fwrite($recvfp, sprintf("%s %s\n", 'timeout', sprintf("%.4f", $t2-$t1) ) );
    else 
        fwrite($recvfp, sprintf("%s %s %s\n", 'elapsed', sprintf("%.4f", $t2-$t1), $r ) );
    $reqcnt += 1;
}
fclose($sendfp);
fclose($recvfp);

function usecurl($post_data, $url){
    global $timeout;
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_URL, $url);
    curl_setopt($curl, CURLOPT_HEADER, false);
    curl_setopt($curl, CURLOPT_POST, true);
    curl_setopt($curl, CURLOPT_POSTFIELDS, $post_data);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($curl, CURLOPT_TIMEOUT, $timeout);
    $data = curl_exec($curl);
    return $data;
}
?>
