<?php
$key = ftok(dirname(__FILE__) . '/token.php', 'S'); 

// Creating a shared memory segment with a key, we need to use an integer value.
$shmId = shm_attach($key); 
$var_key = 99;
$semId = sem_get($key);

$func = $argv[1];
switch ($func) {
default:
    echo "INVALID REQUEST" . PHP_EOL;
    break;

case "reset":
    if(!shm_remove($shmId)) echo "remove shm failed\n"; else echo "shm removed\n";
    if(!sem_remove($semId)) echo "remove sem failed\n"; else echo "sem removed\n";
    break;

case "status":
    while(1) {
        $cnt= chk_cnt();
        unset($out);
        exec("ps -ef | grep www-data | wc -l", $out);
        echo "shared memroy=>{$cnt}  apache2 child processes {$out[0]}\n";
        sleep(1);
    }
    break;
}
/* check counter value */
function chk_cnt() {
    global $shmId, $var_key, $semId;

    // Put a lock. There's a caveat. If another process will encounter this lock,
    // it will wait until the lock is removed 
    sem_acquire($semId);

    // Check if we have the requested variables.
    if (shm_has_var($shmId, $var_key)) {
        // If so, read the data
        $val= shm_get_var($shmId, $var_key);
    } else 
        $val = 0;

    // Releases the lock. 
    sem_release($semId);
    return $val;
}
?>

